<?php

class Sprypay extends PaymentModule
{
		private	$_html = '';
	private $_postErrors = array();
	
	public function __construct()
    {
        $this->name    = 'sprypay';
        $this->tab     = 'Payment';
        $this->version = '0.2';

        $this->currencies = true;
        $this->currencies_mode = 'checkbox';

        parent::__construct();

		$config = Configuration::getMultiple(array('SPRYPAY_SHOP_ID','SPRYPAY_SHOP_SECRET','SPRYPAY_SHOP_LOG','SPRYPAY_TEST'));
		if (isset($config['SPRYPAY_SHOP_ID']))
			$this->shopId = $config['SPRYPAY_SHOP_ID'];
		if (isset($config['SPRYPAY_SHOP_SECRET']))
			$this->shopSecret = $config['SPRYPAY_SHOP_SECRET'];
		if (isset($config['SPRYPAY_SHOP_LOG']))
			$this->log = $config['SPRYPAY_SHOP_LOG'];
		if (isset($config['SPRYPAY_TEST']))
			$this->test = $config['SPRYPAY_TEST'];
        parent::__construct();

        $this->_errors = array();
        $this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Sprypay');
        $this->description = $this->l('Accepts payments by different payment systems (Webmoney, Qiwi, LiqPay, W1, RBKMoney and etc.).');
        $this->confirmUninstall = $this->l('Are you sure you want to delete your details?');
        
		if (!isset($this->shopId))
			$this->warning = $this->l('Add any purse');
		if (!isset($this->shopSecret))
			$this->warning = $this->l('Add secret key');
		

    }
	
	public function install()
	{
		if (!parent::install()
			|| !$this->registerHook('payment')
			|| !$this->registerHook('paymentReturn'))
			return false;
		
}
	
		public function uninstall()
	{
		if (!Configuration::deleteByName('SPRYPAY_SHOP_ID')
				OR !Configuration::deleteByName('SPRYPAY_SHOP_SECRET')
			OR !Configuration::deleteByName('SPRYPAY_SHOP_LOG')
			OR !Configuration::deleteByName('SPRYPAY_TEST')
				OR !parent::uninstall())
			return false;
		return true;
	}
	
		private function _postValidation()
	{
		if (isset($_POST['submitSprypay']))
		{
			if (empty($_POST['shopId']))
				$this->_postErrors[] = $this->l('Add any purse');
			if (empty($_POST['shopSecret']))
				$this->_postErrors[] = $this->l('Add secret key');
		}
	}

	private function _postProcess()
	{
		if (isset($_POST['submitSprypay']))
		{
			Configuration::updateValue('SPRYPAY_SHOP_ID', $_POST['shopId']);
			Configuration::updateValue('SPRYPAY_SHOP_SECRET', $_POST['shopSecret']);
			Configuration::updateValue('SPRYPAY_SHOP_LOG', $_POST['log']);
			Configuration::updateValue('SPRYPAY_TEST', $_POST['test']);
			$file = dirname(__FILE__).'/sprypay.sql';
			if (file_exists($file))
			{
		$sqlContent = file_get_contents($file);
		$sqlContent .= "\n";
		$sqlContent = str_replace('PREFIX_', _DB_PREFIX_, $sqlContent);
		$sqlContent = preg_split("/;\s*[\r\n]+/", $sqlContent);
		foreach ($sqlContent as $query)
		{
			$query = trim($query);
			if (!empty($query))
            $db=Db::getInstance()->Execute($query);
		}
		if($db)unlink($file);
	}
		}

		$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Settings updated').'</div>';
	}

	private function _displaySprypay()
	{
		$this->_html .= '
		<img src="../modules/sprypay/sprypay.gif" style="float:left; margin-right:15px;" />
		<b>'.$this->l('This module allows you to accept payments by SPRYPAY.').'</b><br /><br />
		<br /><br />';
	}
			
private function _displayForm()
	{
		$this->_html .=
		'<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Settings').'</legend>
			<div><label>'.$this->l('shopId:').'</label>
			<div class="margin-form"><input type="text" size="33" maxlength="36" name="shopId" value="'.htmlentities(Tools::getValue('shopId', $this->shopId), ENT_COMPAT, 'UTF-8').'" />
			<p>'.$this->l('Input shop ID').' </p></div>
			<div><label>'.$this->l('shopSecret:').'</label>
			<div class="margin-form"><input type="text" size="33" maxlength="30" name="shopSecret" value="'.htmlentities(Tools::getValue('shopSecret', $this->shopSecret), ENT_COMPAT, 'UTF-8').'" />
			<p>'.$this->l('Input Secret Key').'</p>
			</div>
			<div><label>'.$this->l('Log:').'</label>
			&nbsp;&nbsp;<input type="checkbox" name="log" class="noborder"';
			if($this->log) $this->_html .='checked="checked"';
				 $this->_html .='/></div>
				 	 <br /><div><label>'.$this->l('Test Mode:').'</label>&nbsp;
				 
<input type="radio" name="test" id="test_0" value="0" ';
if($this->test==0) $this->_html .='checked="checked" ';
						 $this->_html .='/>
<label class="t" for="test_0">';
if($this->test!=0) $this->_html .='<img src="../img/admin/enabled.gif" alt="'.$this->l('Enabled').'" title="'.$this->l('Test Mode On').'" /></label>';
	else  $this->_html .='<img src="../img/admin/disabled.gif" alt="'.$this->l('Disabled').'" title="'.$this->l('Test Mode Off').'" /></label>';
							 	 
$this->_html .='&nbsp;&nbsp;
<input type="radio" name="test" id="test_1" value="1"'; 					 if($this->test==1) $this->_html .='checked="checked" ';
						 $this->_html .='/>
<label class="t" for="test_1">';
if($this->test==1) $this->_html .='<img src="../img/admin/enabled.gif" alt="'.$this->l('Enabled').'" title="'.$this->l('Test with SpryPay On').'" /></label>';
	else  $this->_html .='<img src="../img/admin/disabled.gif" alt="'.$this->l('Disabled').'" title="'.$this->l('Test with SpryPay Off').'" /></label>';
		
$this->_html .='&nbsp;&nbsp;
<input type="radio" name="test" id="test_2" value="2"'; 					 if($this->test==2) $this->_html .='checked="checked" ';
						 $this->_html .='/>';		
$this->_html .='&nbsp;<label class="t" for="test_2">';
if($this->test==2) $this->_html .='<img src="../img/admin/enabled.gif" alt="'.$this->l('Enabled').'" title="'.$this->l('Test with self On').'" /></label>';
	else  $this->_html .='<img src="../img/admin/disabled.gif" alt="'.$this->l('Disabled').'" title="'.$this->l('Test with self Off').'" /></label>';

				 $this->_html .=' </div>
			<br /><center><input type="submit" name="submitSprypay" value="'.$this->l('Save').'" class="button" /></center>
		</fieldset>
		</form><br /><br />
		<fieldset class="width3">';
	}
	
		public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';

		if (!empty($_POST))
		{
			$this->_postValidation();
			if (!sizeof($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors AS $err)
					$this->_html .= '<div class="alert error">'. $err .'</div>';
		}
		else
			$this->_html .= '<br />';

		$this->_displaySprypay();
		$this->_displayForm();

		return $this->_html;
	}
	
		public function hookPayment($params)
	{
		if (!$this->active)
			return ;
	//-------------------------------------------------
        $retval=false;
		$allowedCurrencies = $this->getCurrency();
		foreach ($allowedCurrencies AS $a)
			{
			if($a['id_currency']==$params['cart']->id_currency){
			$retval=true;
			break;
			}
		}
		if(!$retval)return ;
	//-------------------------------------------------
		global $smarty;

		$smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_ssl' => (Configuration::get('PS_SSL_ENABLED') ? 'https://' : 'http://').htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'modules/sprypay/'
		));
		return $this->display(__FILE__, 'payment.tpl');
	}
	
		public function execPayment($cart)
	{
		if (!$this->active)
 		{
		 	return;
 		}

		global $cookie,$smarty;
		$id_currency = intval($cart->id_currency);
		$currency = new Currency(intval($id_currency));
			$rur_currency = new Currency(intval(Currency::getIdByIsoCode('RUR')));
		$uri=$_SERVER['REQUEST_URI'];
		if(strpos($uri,'order_confirm_payment.php')>0)
		{
		$amount_output=$cart->getOrderTotal(true, 3)/$currency->conversion_rate;
		$spShopId = Configuration::get('SPRYPAY_SHOP_ID');
	    $spAmount = number_format($amount_output*$rur_currency->conversion_rate, 2, '.', '');
	    if (!$cookie->id_lang) $langId = (int) Configuration::get('PS_LANG_DEFAULT');
else $langId = (int) $cookie->id_lang;	
$language = strtolower(Language::getIsoById($langId));
if ($language != 'ru')
$language = 'en';
if(!$spUserEmail) $spUserEmail='admin@esculap.in';
		$smarty->assign(array(
			'spShopId' => $spShopId,
			'spShopPaymentId'=> intval($cart->id),
			'spAmount' => $spAmount,
			'this_path' => $this->_path,
			'spUserEmail' => $spUserEmail,
			'lang' => $language,
		));
if($this->test==2) {
$spPaymentId= intval($cart->id)*2;
			$sing_hash_str =  $spPaymentId.$spShopId.intval($cart->id).'5.10'.$spAmount.'rur'.$spUserEmail.'тестовый платеж'.'1'.'6.41'.'296711'.'2012-03-07 17:07:43'.Configuration::get('SPRYPAY_SHOP_SECRET');
		
				$sing_md5 = md5($sing_hash_str);
				$smarty->assign(array(
			'spPaymentId' => $spPaymentId,
'spHashString'=>$sing_md5
		));		
return $this->display(__FILE__, 'test_payment_sprypay.tpl');
}
	return $this->display(__FILE__, 'payment_sprypay.tpl');
 		}
else{
		$amount_output=$cart->getOrderTotal(true, 3)/$currency->conversion_rate;
		$total = number_format($amount_output*$rur_currency->conversion_rate, 2, '.', '');
		$smarty->assign(array(
			'nbProducts' 		=> $cart->nbProducts(),
			'total' => $total,
			'this_path' => $this->_path,
			'this_path_ssl' 	=> (Configuration::get('PS_SSL_ENABLED') ? 'https://' : 'http://').htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'modules/sprypay/'
		));
 		return $this->display(__FILE__, 'payment_execution.tpl');	
}
	}
	
}
